package ui.controller;

import ui.model.iDCounter;
import Interfaces.ObjectListener;
import classes.CpsObject;
import ui.model.Model;

public class CanvasController {

	private iDCounter ID;
	private Model MODEL;

	public CanvasController(Model model, iDCounter id) {
		this.ID = id;
		this.MODEL = model;
	}

	/**
	 * Add an CpsObject to the model and notify the ObjectListener for update.
	 * 
	 * @param object
	 *            CpsObject to be added.
	 */
	public void addObjectIntoCanvas(CpsObject object) {
		String name = object.getObjName();
		MODEL.getObjectsOnCanvas().add(object);
		notifyObjListeners();
		System.out.println("Added: " + name);
	}

	/**
	 * notifies all listeners about changes in the Canvas
	 */
	public void notifyObjListeners() {
		for (ObjectListener l : MODEL.getObjectListeners()) {
			l.onChange(MODEL.getObjectsOnCanvas());
		}
	}

}
